#include <PSX/GTE/gte.hpp>

namespace JabyEngine {
    namespace GTE {
        MATRIX& multiply_matrix(const MATRIX& m0, const MATRIX& m1, MATRIX& result) {
            set_rot_matrix(m0);
            
            JabyEngine::GTE::ldclmv(m1, 0);
            JabyEngine::GTE::rtir();
            JabyEngine::GTE::stclmv(result, 0);
            
            JabyEngine::GTE::ldclmv(m1, 1);
            JabyEngine::GTE::rtir();
            JabyEngine::GTE::stclmv(result, 1);
            
            JabyEngine::GTE::ldclmv(m1, 2);
            JabyEngine::GTE::rtir();
            JabyEngine::GTE::stclmv(result, 2);

            return result;
        }
    }
}